/*
 * Skytils - Hypixel Skyblock Quality of Life Mod
 * Copyright (C) 2021 Skytils
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package skytils.skytilsmod.mixins.transformers.neu;

import org.spongepowered.asm.mixin.Dynamic;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Pseudo;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import skytils.skytilsmod.utils.NEUCompatibility;

@Pseudo
@Mixin(targets = "io.github.moulberry.notenoughupdates.miscfeatures.StorageManager", remap = false)
public class MixinStorageManager {
    @Dynamic
    @Shadow
    private boolean shouldRenderStorageOverlayCached = false;

    @Dynamic
    @Inject(method = "shouldRenderStorageOverlay", at = @At("RETURN"))
    private void updateStorageSet(String containerName, CallbackInfoReturnable<Boolean> cir) {
        NEUCompatibility.INSTANCE.setStorageMenuActive(shouldRenderStorageOverlayCached);
    }
}
